SLASH_NKEYSTONE1 = '/nklist';

local ADDON_PREFIX = "NKEYSTONE";
local KEYSTONE_ITEMID = 138019;
local REQUESTINFO = "NKEYSTONEREQUESTINFO"

RegisterAddonMessagePrefix(ADDON_PREFIX);

function SlashCmdList.NKEYSTONE(msg, editbox)
	GetKeystoneInfo();
end

function GetKeystoneInfo()
	print("NK: Requesting Keystone Info");
	SendAddonMessage(ADDON_PREFIX, REQUESTINFO, "GUILD");
end

function SendKeystoneInfo(target)
	--print("NK: Sending keystone info to: " .. target);
	local bagID, slotID = GetBagAndSlotIDForKeystone();
	local itemLink = GetItemLinkFromBagAndSlotID(bagID, slotID);
	if itemLink ~= nil then
		dist = target and "WHISPER" or "GUILD";
		SendAddonMessage(ADDON_PREFIX, itemLink, dist, target);
	end
end

function GetBagAndSlotIDForKeystone()
	for bagID = 0, NUM_BAG_SLOTS do
		local slotCount = GetContainerNumSlots(bagID);
		for slotID = 0, slotCount do
			local itemID = GetContainerItemID(bagID, slotID);
			if itemID == KEYSTONE_ITEMID then
				return bagID, slotID;
			end
		end
	end
	return nil;
end

function GetItemLinkFromBagAndSlotID(bagID, slotID)
	if bagID == nil or slotID == nil then
		return nil;
	end

	local texture, itemCount, locked, quality, readable, lootable, itemLink
		= GetContainerItemInfo(bagID, slotID);
	return itemLink;
end

function GetItemStringFromItemLink(itemLink)
	return select(3, strfind(itemLink, "|H(.+)|h"));
end

NKeystone = {
};

local nkt = NKeystone;

local eventFrame = CreateFrame("FRAME");
eventFrame:RegisterEvent("CHAT_MSG_ADDON");
eventFrame:SetScript("OnEvent", function(...) nkt.OnEvent(...); end);

nkt.OnEvent = function(self, event, ...)
	local args = ...
	if event == "CHAT_MSG_ADDON" then
		local prefix, msg, dist, sender = ...;
		if prefix == ADDON_PREFIX then
			if msg == REQUESTINFO then
				SendKeystoneInfo(sender);
			else
				print("NK: " .. sender .. ": " .. msg);
			end
		end
	end
end